#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cmath>

using namespace std;

struct plane{
    int startPlanet, speed, price, capacity;
};

struct flight{
    int startHour, endHour, month, profit, capacity, used;
};

struct edge{
    int from, to, dist;
    vector < flight > flights;
};

struct out{
    int planet, day, start;
};

vector < edge > V[644];
plane P[644];
vector < out > res[644];
int N, M, F;
int D[644][644];
int a[644][644];
int used[64][64][80];

void scan(){
    cin >> N >> M >> F;
    for ( int i = 0; i < M; ++i )
        cin >> P[i].startPlanet >> P[i].speed >> P[i].price >> P[i].capacity;

    for ( int i = 0; i < F; ++i ){
        edge t;
        int K;
        cin >> t.from >> t.to >> t.dist >> K;


        while ( K -- ){
            flight tmp;
            cin >> tmp.startHour >> tmp.endHour >> tmp.month >> tmp.profit >> tmp.capacity;
            tmp.used = 0;
            t.flights.push_back ( tmp );
        }

        V[t.from].push_back ( t );
    }
}

bool bySpeed ( plane t1, plane t2 ){
    return t1.speed > t2.speed;
}

bool byCapacity ( flight t1, flight t2 ){
    return t1.capacity > t2.capacity;
}

int getNext ( int from, int to ){

    for ( int i = 1; i <= N; ++i )
        if ( a[from][i] ) if ( i != from && D[i][to] + a[from][i] == D[from][to] && a[from][i] )
            return i;

    return -1e9;
}

int getBack ( int time, int from, int to, int idx, int toMark ){
    while ( from != to ){
      //  cout << from << " " << to << endl;
    //    cout << from << " " << to << endl;
        int nw = getNext ( from, to ), dd;
        dd = ceil ( a[from][nw] / (double)P[idx].speed );
         while ( used[from][nw][time % 16] || time % 16 + dd > 16 ){
            ++time;

         }

        if ( toMark ){

            used[from][nw][ ( time + 16 ) % 64 ] = -1;
            used[from][nw][ ( time + 32 ) % 64 ] = -1;
            used[from][nw][ ( time + 48 ) % 64 ] = -1;
            used[from][nw][time] = toMark;
        }
        time += dd;
        from = nw;
    }

    return time;
}

void dfs ( int i, int time, int idx ){
   // cout << i << " -- " << time << endl;
    for ( int j = 0; j < V[i].size(); ++j )
        for ( int k = 0; k < V[i][j].flights.size(); ++k ){
            int tt = time;
                while ( tt % 16 != V[i][j].flights[k].startHour )
                    ++tt;

           // cout << V[i][j].to << " " <<  tt << " " << used[i][ V[i][j].to][ tt ] << " " << endl;
            if ( !used[i][ V[i][j].to][ tt ] &&!V[i][j].flights[k].used && V[i][j].dist <= ( V[i][j].flights[k].endHour - V[i][j].flights[k].startHour ) * P[idx].speed ){

                int timeThere = tt+ ceil ( V[i][j].dist / (double)P[idx].speed );

                if ( timeThere % 16 < 4 )
                    continue;

                if ( V[i][j].flights[k].startHour < 4 )
                    continue;
                if ( getBack ( timeThere , V[i][j].to, P[idx].startPlanet, idx, 0 ) <= 64 ){
                    int from = i, nw = V[i][j].to;
                    used[from][nw][ ( tt + 16 ) % 64 ] = -1;
                    used[from][nw][ ( tt + 32 ) % 64 ] = -1;
                    used[from][nw][ ( tt + 48 ) % 64 ] = -1;
               //     cout << V[i][j].to << endl;
                    used[from][nw][tt] = idx + 1;
                    V[i][j].flights[k].used = idx + 1;
                    dfs ( V[i][j].to, timeThere, idx );
                    return;
                }
            }
    }
    getBack ( time, i, P[idx].startPlanet, idx, idx + 1 );
}

vector < out > getRandomCycle( plane t, int idx ){
    dfs ( t.startPlanet, 0, idx);

    vector < out > ret;

   for ( int k = 0; k < 64; ++k )
        for ( int i = 1; i < 64; ++i )
            for ( int j = 1; j < 64; ++j )
                if ( used[i][j][k] == idx + 1 ){
                    out tmp;
                    tmp.planet = j;
                    tmp.day = k / 16;
                    tmp.start = k % 16;
                    ret.push_back ( tmp );
                }
    if ( !ret.size() ){

    int start = t.startPlanet;
    for ( int i = 0; i < V[start].size(); ++i ){
        int beg = 0;
        int dd = ceil ( V[start][i].dist / (double)P[idx].speed );;
        while ( used[start][V[start][i].to][beg] || beg % 16 + dd > 16  ){++beg;
            if ( beg > 64 ) break;
        }

        if ( beg >= 64 ) continue;

        int timeThere = beg + ceil ( V[start][i].dist / (double)P[idx].speed );

            used[start][V[start][i].to][ ( beg + 16 ) % 64 ] = -1;
            used[start][V[start][i].to][ ( beg + 32 ) % 64 ] = -1;
            used[start][V[start][i].to][ ( beg + 48 ) % 64 ] = -1;
            used[start][V[start][i].to][beg] = idx + 1;
        if ( getBack ( timeThere, V[start][i].to, start, idx, 0) <= 64 ){
            getBack ( timeThere, V[start][i].to, start, idx, idx + 1);
            break;
        }
            used[start][V[start][i].to][ ( beg + 16 ) % 64 ] = 0;
            used[start][V[start][i].to][ ( beg + 32 ) % 64 ] = 0;
            used[start][V[start][i].to][ ( beg + 48 ) % 64 ] = 0;
            used[start][V[start][i].to][beg] = 0;
    }
    for ( int k = 0; k < 64; ++k )
        for ( int i = 1; i < 64; ++i )
            for ( int j = 1; j < 64; ++j )
                if ( used[i][j][k] == idx + 1 ){
                    out tmp;
                    tmp.planet = j;
                    tmp.day = k / 16;
                    tmp.start = k % 16;
                    ret.push_back ( tmp );
                }
    }

    return ret;
}

void shortestPaths(){

    for ( int i = 1; i <= N; ++i )
        for ( int j = 1; j <= N; ++j )
            if ( i != j )
                D[i][j] = 1e9;

    for ( int i = 1; i <= N; ++i )
        for ( int j = 0; j < V[i].size(); ++j )
            a[ V[i][j].from ][ V[i][j].to ] = D[ V[i][j].from ][ V[i][j].to ] = V[i][j].dist;

    for ( int k = 1; k <= N; ++k )
        for ( int i = 1; i <= N; ++i )
            for ( int j = 1; j <= N; ++j )
                if ( D[i][j] > D[i][k] + D[k][j] )
                    D[i][j] = D[i][k] + D[k][j];
}
void solve(){
    for ( int i= 0; i < 64; ++i )
        for ( int j = 0; j < 64; ++j )
            for ( int k = 0; k < 64; ++k )
                if ( k % 16 < 4 )
                    used[i][j][k] = -1;
    for ( int i = 1; i <= N; ++i )
        for ( int j = 0; j < V[i].size(); ++j )
            sort ( V[i][j].flights.begin(), V[i][j].flights.end(), byCapacity );

    shortestPaths();

    for ( int i = 0; i < M; ++i ){
         //   cout << i << "\n\n\n";

        res[i] = getRandomCycle( P[i], i );
    }

    for ( int i = 0; i < M; ++i ){
        cout << res[i].size() << "\n";
        int prev = P[i].startPlanet;
   //     cout << prev << endl;
        for ( int j = 0; j < res[i].size(); ++j ){

            cout << res[i][j].day + 1 << " " << res[i][j].start << " " << res[i][j].planet << endl;
        }
    }
}

int main(){
    freopen ("flights.in", "r", stdin );
    freopen ("flights.out", "w", stdout );

    scan();
    solve();
}
